image: docker:latest
services:
  - docker:dind

stages:
  - build
  - deploy

variables:
  CONTAINER_IMAGE: cnjioru/palindrome:${CI_COMMIT_SHORT_SHA}

build:
  stage: build
  script:
    #- docker login -u ${DOCKER_USER} -p ${DOCKER_PASSWORD}
    - docker login registry.gitlab.com
    - docker build -t registry.gitlab.com/festus.were/palindrome-api .
    - docker push registry.gitlab.com/festus.were/palindrome-api
    #- docker build -t ${CONTAINER_IMAGE} .
    #- docker tag ${CONTAINER_IMAGE} ${CONTAINER_IMAGE}
    #- docker tag ${CONTAINER_IMAGE} cnjioru/palindrome:latest
    #- docker push ${CONTAINER_IMAGE}
deploy:
  stage: deploy
  image: dtzar/helm-kubectl
  script:
    - kubectl config set-cluster k8s --server="${SERVER}"
    - kubectl config set clusters.k8s.certificate-authority-data ${CERTIFICATE_AUTHORITY_DATA}
    - kubectl config set-credentials gitlab --token="${USER_TOKEN}"
    - kubectl config set-context default --cluster=k8s --user=gitlab
    - kubectl config use-context default
    - helm init --client-only
    - helm upgrade palindrome ./ --install --set image.tag=${CI_COMMIT_SHORT_SHA}